## Course Description

This course will introduce researchers to Jupyter notebooks as a tool for
conducting research and for communicating their work.

The [Jupyter ecosystem](https://jupyter.org) is a rich environment for
interactive computing which provides intuitive and powerful tools for
data-analysis, computation and collaboration. We will explore the features of
the [jupyter notebook](https://jupyter-notebook.readthedocs.io/en/stable/) and
the Python(3) programming language. Specifically, we will look at:

  * [Notebooks](./notebooks/): Markdown, Code, Output, widgets, %magics
  * [Python](./python/): Types, Structures, Loops, Control Flow, Logic
  * Some useful modules
    - [numpy](./numpy/)
    - [matplotlib](./matplotlib/)
    - [pandas](./pandas/)
    - Others (not covered here)
      - [beautiful soup](https://www.crummy.com/software/BeautifulSoup/bs4/doc/)
      - domain specific: [astropy](https://www.astropy.org/), [nltk](https://www.nltk.org/), ...
  * Examples
    - [GitHub + APIs](./examples/github/)
    - [Sympy + Widgets](./examples/sympyAndWidgets/)
    - [Text analysis](./examples/entropy/)
  * Useful links:
    * [A gallery of interesting Jupyter Notebooks](https://github.com/jupyter/jupyter/wiki/A-gallery-of-interesting-Jupyter-Notebooks)
    * [mybinder.org](https://gke.mybinder.org/) Turn a Git repo into an interactive notebook
    * [Jupyter Blog](https://blog.jupyter.org/)
    * [Python Data Science Handbook](https://jakevdp.github.io/PythonDataScienceHandbook/)
    * [JupyterLab](https://github.com/jupyterlab/jupyterlab) (part of) the future for Jupyter

We will use some popular Python packages (Pandas, Numpy, Sympy, ...)
to work through a series of examples and exercises to see how they can be used
to work with external data sources, produce insights and visualizations and help
create compelling showcases of your work.

This course does not have any firm requirements, but some familiarity with
Python would be helpful.
